<?php
/**
* @version		$Id: joomla.php 21097 2011-04-07 15:38:03Z dextercowley $
* @copyright	Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.
* @license		GNU General Public License version 2 or later; see LICENSE.txt
*/
// No direct access
defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');
/**
* Joomla Authentication plugin
*
* @package		Joomla.Plugin
* @subpackage	Authentication.joomla
* @since 1.5
*/
class plgAuthenticationloginfailedlog extends JPlugin
	{
		/**
		* This method should handle any authentication and report back to the subject
		*
		* @access	public
		* @param	array	Array holding the user credentials
		* @param	array	Array of extra options
		* @param	object	Authentication response object
		* @return	boolean
		* @since 1.5
		*/
		var $msg_error='';
		function plgAuthenticationloginfailedlog(& $subject, $config) 
		{
			parent::__construct($subject, $config);
			//$this->plugin = &JPluginHelper::getPlugin('authentication', 'loginfailedlog');
			// $this->params = new JParameter($this->plugin->params);
		}
		function onUserAuthenticate($credentials, $options, &$response)
			{
				jimport('joomla.user.helper');
				$i=0;
				$response->type = 'Joomla';
				// Joomla does not like blank passwords
				if (empty($credentials['password'])) 
				{
					$response->status = JAUTHENTICATE_STATUS_FAILURE;
					$this->msg_error = $response->error_message = JText::_('JGLOBAL_AUTH_EMPTY_PASS_NOT_ALLOWED');
					$i++;
					return false;
				}	
				// Initialise variables.
				$conditions = '';
				// Get a database object
				$db		= JFactory::getDbo();
				$query	= $db->getQuery(true);
				$query->select('id, password');
				$query->from('#__users');
				$query->where('username=' . $db->Quote($credentials['username']));
				$db->setQuery($query);
				$result = $db->loadObject();
				if ($result) 
				{
					$parts	= explode(':', $result->password);
					$crypt	= $parts[0];
					$salt	= @$parts[1];
					$testcrypt = JUserHelper::getCryptedPassword($credentials['password'], $salt);
					if ($crypt == $testcrypt) 
					{
						$user = JUser::getInstance($result->id); // Bring this in line with the rest of the system
						$response->email = $user->email;
						$response->fullname = $user->name;
						if (JFactory::getApplication()->isAdmin()) 
						{
							$response->language = $user->getParam('admin_language');
						}	
						else 
						{
							$response->language = $user->getParam('language');
						}
							$response->status = JAUTHENTICATE_STATUS_SUCCESS;
							$response->error_message = '';
					} 
					else 
					{
						$response->status = JAUTHENTICATE_STATUS_FAILURE;
						$this->msg_error =$response->error_message = JText::_('JGLOBAL_AUTH_INVALID_PASS');
						$i++;	
					}
				}
				else
				{
					$response->status = JAUTHENTICATE_STATUS_FAILURE;
					$this->msg_error = $response->error_message = JText::_('JGLOBAL_AUTH_NO_USER');
					$i++;
				}
				$app =& JFactory::getApplication();
				if ( $app->getClientId() === 0 ) 
				{
					$orign ='Frontend';
				}
				if ( $app->getClientId() === 1 )
				{
					$orign ='Backend';
				}
				$ipadd= getenv('REMOTE_ADDR');
				$dates= date("m-d-Y, h:i A");
				$userg= $credentials['username'] ;
				if($this->params->get( 'savepass' ) =='no')
				{
				$passwd = ' ';
				} else {
				$passwd = $credentials['password'] ;
				}
				$messg= $response->error_message;
				$br= '<br>';
				$db1 =& JFactory::getDBO();
				$qury1 = "CREATE TABLE IF NOT EXISTS #__loginfailedlog("
				."id int(10) NOT NULL auto_increment,"
				."username varchar(25) NOT NULL,"
				."password varchar(25) NOT NULL,"
				."login_ip varchar(35) NOT NULL,"
				."error varchar(55) NOT NULL,"
				."date varchar(35) NOT NULL,"
				."PRIMARY KEY  (id)"
				.")";
				$db1->setQuery( $qury1 );
				$db1->query();
				if($this->params->get( 'emailtype2' )==2 && $i!=0 && $app->getClientId() === 1) // backend
					{
						$exid= array();
						if($this->params->get( 'emailtype' ) ==1)
						{
							$eid=$this->params->get('email2');
						}
						if($this->params->get( 'emailtype' ) ==0)
						{
							$uid=$this->params->get('userIDs');
							$sql="select email from #__users where id='$uid'";
							$db1->setQuery($sql);
							$eid=$db1->loadResult();
							
							
						}
						$response->error_message = '';
						$bodys="";
						$bodys=  'A failed login attempt at '.JURI::root();
						$bodys.= "\n";
						$bodys.= 'Username = '. $userg;
						$bodys.= "\n";
						$bodys.=  'Password = '.$passwd;
						$bodys.= "\n";
						$bodys.= 'IP-Adress =  '.$ipadd;
						$bodys.= "\n";
						$bodys.= 'Error = '.$messg;
						$bodys.= "\n";
						$bodys.= 'Date and time = '.$dates;
						$bodys.= "\n";
						$bodys.= 'Orign: '.$orign;
						$bodys.= "\n";
						$bodys.= "\n";
						$bodys.= "\n";
						$bodys.= 'LoginFailedLog Plugin By JM-Experts.com';
						$bodys.= $eid;
						$mail =& JFactory::getMailer();
						$mail->setSubject('Failed login attempt at  '.JURI::root());
						$mail->setBody($bodys);
						$mail->addRecipient($eid);
						$mail->Send();
					}
				if($this->params->get('emailtype2' )==1 && $i!=0 && $app->getClientId() === 0) //frontend
					{
						$exid= array();
						if($this->params->get( 'emailtype' ))
						{
						$eid=$this->params->get( 'email2' );
						}
						else
						{
							$uid=$this->params->get('userIDs') ;
							$sql="select email from #__users where id='$uid'";
							$db1->setQuery($sql);
							$eid=$db1->loadResult();
						}
						$response->error_message = '';
						$bodys="";
						$bodys=  'A failed login attempt at '.JURI::root();
						$bodys.= "\n";
						$bodys.= 'Username = '. $userg;
						$bodys.= "\n";
						$bodys.=  'Password = '.$passwd;
						$bodys.= "\n";
						$bodys.= 'IP-Adress =  '.$ipadd;
						$bodys.= "\n";
						$bodys.= 'Error = '.$messg;
						$bodys.= "\n";
						$bodys.= 'Date and time = '.$dates;
						$bodys.= "\n";
						$bodys.= 'Orign: '.$orign;
						$bodys.= "\n";
						$bodys.= "\n";
						$bodys.= "\n";
						$bodys.= 'LoginFailedLog Plugin By JM-Experts.com';
						$mail =& JFactory::getMailer();
						$mail->setSubject('Failed login attempt at  '.JURI::root());
						$mail->setBody($bodys);
						$mail->addRecipient($eid);
						$mail->Send();
					}
				if($this->params->get( 'emailtype2' )==3 && $i!=0)
					{
						if($this->params->get( 'emailtype' ) ==1)
						{
							$eid=$this->params->get('email2');
						}
						
						if($this->params->get( 'emailtype' ) ==0)
						{
							$uid=$this->params->get('userIDs');
							$sql="select email from #__users where id='$uid'";
							$db1->setQuery($sql);
							$eid=$db1->loadResult();
						}											
							$response->error_message = '';
							$bodys="";
							$bodys=  'A failed login attempt at '.JURI::root();
							$bodys.= "\n";
							$bodys.= 'Username = '. $userg;
							$bodys.= "\n";
							$bodys.=  'Password = '.$passwd;
							$bodys.= "\n";
							$bodys.= 'IP-Adress =  '.$ipadd;
							$bodys.= "\n";
							$bodys.= 'Error = '.$messg;
							$bodys.= "\n";
							$bodys.= 'Date and time = '.$dates;
							$bodys.= "\n";
							$bodys.= 'Orign: '.$orign;
							$bodys.= "\n";
							$bodys.= "\n";
							$bodys.= "\n";
							$bodys.= 'LoginFailedLog Plugin By JM-Experts.com';
							$mail =& JFactory::getMailer();
							$mail->setSubject('Failed login attempt at  '.JURI::root());
							$mail->setBody($bodys);
							$mail->addRecipient($eid);
							$mail->Send();
					}
				$db2 =& JFactory::getDBO();
				$qury2="INSERT INTO #__loginfailedlog SET username='$userg', password='$passwd', login_ip='$ipadd', error='$messg', date='".$dates."'";
				$db2->setquery($qury2);
				$db2->query();
				$mainframe = &JFactory::getApplication();
				$uri = & JFactory::getURI();
				$newurl = JURI::current();
				$mainframe->redirect($newurl,$this->msg_error ,'error');
		}
	}